from podapi_utils import *

def main():

    """ pods related rest calls """
    # get list of all pods
    response = call_api('get', 'pods')
    print('GET pods response : \n %s' % response)

    # add new pod
    # use valid field names!
    new_pod_details = {
        "pod_health": "Green",
        "location_id": 1,
        "pod_numtotaldoors": 10,
        "pod_numfreedoors": 5,
        "pod_name": "1895"
        }

    response = call_api('post', 'pods', data=json.dumps(new_pod_details))
    print('New pod added with record id : [%s] ' % response['records']['id'])
    print('POST pods response: \n %s' % response)

    # update existing pod's fields
    pod_record_id = 70
    update_pod_details = {"pod_health": "Yellow", 'pod_details': 'The details have been updated'}  # use valid field names!
    response = call_api('patch', 'pods/'+str(pod_record_id), data=json.dumps(update_pod_details))
    print('PATCH pods response : \n %s' % response)

    # delete existing pod's record
    pod_record_id = 70
    response = call_api('delete', 'pods/'+str(pod_record_id), params={'record_id': 1000})
    print('DELETE pods response : \n %s' % response)

    # *************************************************************************************************************

    # logging related calls

    response = call_api('get', 'logs')
    print('GET logs response : \n %s' % response)

    new_log_entry = {"log_eventtime": "2021-12-24T14:55:00", "log_level": "INFO",
                     "log_type": "pod", "log_message": "Test log", "log_id": "15457"}

    response = call_api('post', 'logs', data=json.dumps(new_log_entry))
    print('POST logs response: \n %s' % response)


if __name__ == '__main__':

    podapi_savelog(log_eventtime="Now", log_level="INFO", log_type="pod", log_message="MAIN: loop starting ...", log_id="12345")

    bret = podapi_generate_otp('9845069130')
    print("podapi_generate_otp bret=" + str(bret))
    bret = podapi_validate_otp('9845069130', '9130')
    print("podapi_validate_otp bret=" + str(bret))
    bret = podapi_validate_otp('9845069130', '2222')
    print("podapi_validate_otp bret=" + str(bret))

#    main()
