from enum import Enum
import os


class CommonInfo(Enum):
    def __str__(self):
        return str(self.value)

    POD_CONFIG_FILE = "/root/pod-sd/pod.ini"


class ModemInfo(Enum):
    MODEM_POWER_PIN = 13
    CONFIG_SECTION_NAME = "modem"
    PING_TIMEOUT = 30
    MODEM_MODE_CONFIG = {
        "umts": "AT^SYSCFG=14,2,3FFFFFFF,2,4",
        "gprs": "AT^SYSCFG=13,1,3FFFFFFF,2,4",
        "auto": 'AT^SYSCFGEX="030102",3fffffff,1,2,7fffffffffffffff,,',
        "lte": 'AT^SYSCFGEX="03",3fffffff,1,2,7fffffffffffffff,,'
    }
    AIRTEL_NAME = "AIRTEL"
    TATA_DOCOMO_NAME = "TATA DOCOMO"
    VODAFONE_NAME = "VODAFONE"
    USSD_CODE_MAP = {
        "AIRTEL": "*282#",
        "TATA_DOCOMO": "*580#"
    }
    MODEM_COMM_PORT_NAME = "modem_comm"
    MODEM_DATA_PORT_NAME = "modem_data"
    PREFERRED_NETWORK_TYPE_NAME = "preferred_network_type"
    QMI_LOCK_FILE = "/tmp/qmi_lock"
    QMI_DEVICE_NAME = "/dev/cdc-wdm0"
    SUPPORTED_MODEMS_NAME = "supported_modems"
    E3373_LOCK_FILE = "/tmp/huawei_e3372"
    HUAWEI_NAME = "huawei"
    # AT commands
    HUAWEI_NETWORK_MODE_COMMAND = "AT^HCSQ?"
    OTHER_NETWORK_MODE_COMMAND = "AT+ZPAS?"
    SOFT_RESET_COMMAND = "AT+CFUN=0"
    GET_SERIAL_COMMAND = "AT+CGSN"
    FLASK_EXPOSED_METHODS = ["status", "get_signal_strength", "get_imei_number", "reset", "soft_reset", "hard_reset",
                             "get_imei_number", "get_imsi_number", "get_service_provider", "get_manufacturer",
                             "get_model", "get_revision", "get_sim_number", "get_network_mode", "get_serial", "status",
                             "get_location", "power_reset"]

