import os
from os import path
import logging

LOG_DIR = "/root/pod-sd/log/"

def initializelogger(slogname=str, sdir=str, btoconsole=bool, btofile=bool):
    slogpath = os.path.join(sdir, str(slogname + ".log"))
    logger = logging.getLogger(slogpath)
    logger.setLevel(logging.DEBUG)
    logformat = logging.Formatter('%(asctime)s - %(levelname)-9s| %(message)-100s [L:%(lineno)-04d M:%(module)-s F:%(funcName)-s]', datefmt='%Y-%m-%d %H:%M:%S')
    # create a file handler if log_file is supplied as parameter
    if btofile:
        if (slogpath is not None) and (len(slogpath) > 0):
            filehandler = logging.FileHandler(slogpath, mode='a')
            filehandler.setFormatter(logformat)
            filehandler.setLevel(logging.DEBUG)     # all messages are logged to logfile
            logger.addHandler(filehandler)
    if btoconsole:
        consolehandler = logging.StreamHandler()
        consolehandler.setFormatter(logformat)
        consolehandler.setLevel(logging.INFO)
        logger.addHandler(consolehandler)
    return logger


def test_function():
    Log.info("-- Main Log Started --")
    Log.error("Error: Sample error message")


if 'InitializedGlobalsFlag' not in globals():
    InitializedGlobalsFlag = True
    Log = initializelogger("version_2.0", LOG_DIR, True, True)
    # DevLog = initializelogger("dev_dump", LOG_DIR, False, True)
