from main_includes import *

# **1 from main_lcb import *


def display_update(line=None, style=None, delay=None):
    if line is None:
        line = {}
    if style is None:
        style = ["center", "center", "center", "center"]
    if delay is None:
        delay = 0.0

    """
    This function is used for displaying messages on the lcd screen
    :param line: A dictonary for messages that needs to be displayed.
    :param style: A list for choosing the orientation of the message on the display.
    :return: None
    """
    for i in range(1, 5):
        if line.get(i) is None:
            continue
        lcdobj.lcd_settextline(line.get(i), i, style[i - 1], True)

    if delay > 0.0:
        time.sleep(delay)
    return


def display_setbacklight(state):
    if state is True:
        lcdobj.set_backlight(1)
    else:
        lcdobj.set_backlight(0)
    return


def display_togglebacklight():
    display_setbacklight(True)
    time.sleep(0.5)
    display_setbacklight(False)
    time.sleep(0.5)
    display_setbacklight(True)
    time.sleep(0.5)
    display_setbacklight(False)
    time.sleep(0.5)
    return


def display_clearall():
    lcdobj.lcd_clear(1, 0)
    lcdobj.lcd_clear(2, 0)
    lcdobj.lcd_clear(3, 0)
    lcdobj.lcd_clear(4, 0)
    return


# --- CRITICAL GLOBAL VARIABLES DECLARATION SECTION BELOW ---


Log.info("MAIN_DISPLAY: Started ...")

lcdobj = LcdHardware()
display_setbacklight(True)
# lcdobj.set_backlight(1)
lcdobj.initialize_lcd()
lcdobj.lcd_diagnostics()

Log.info("MAIN_DISPLAY: Completed ...")


# **** DISPLAY UTILITY FUNCTIONS ****


