from main_includes import *

from main_display import *


# *** Replace/merge above code with this below section
#
# 14 keys on keypad: 0-9, CLEAR(-), ENTER(+), #, *
#
def keypad_getchar(maxsecsperchar):
    Log.info("keypad_getchar: start maxsecsperchar=[" + str(maxsecsperchar) + "]")
    keypadobj.check_if_keypad_hung()
    try:
        # Hold the key inside queue for maximum of 3 seconds. if no key is
        # pressed for 3 secs an exception is raised
        hex_key = keypadobj.key_queue.get(timeout=int(maxsecsperchar))
        # all all timeout the screen s updating
        # translate hex key char input to a filtered string alpha value
        filtered_key = keypadobj.key_filter(hex_key)
        # No valid key was pressed
        if filtered_key is None:
            filtered_key = ""
    # When no is key is pressed for maxsecsperchar seconds clear the Queue
    except Queue.Empty:
        filtered_key = ""
    Log.info("keypad_getchar: exit filtered_key=[" + str(filtered_key) + "]")
    return filtered_key


def keypad_getotp(numchars, maxsecsperchar):
    Log.info("keypad_getotp: start numchars=[" + str(numchars) + " maxsecsperchar=[" + str(maxsecsperchar) + "]")

    entered_otp = ""
    while True:

        pressed_key = keypad_getchar(int(maxsecsperchar))
        Log.info("keypad_getotp: entered_otp=[" + entered_otp + "], pressed_key=[" + str(pressed_key) + "]")

        if (pressed_key is None) or (pressed_key == ""):
            Log.info("keypad_getotp: no key entered or None returned")
            entered_otp = entered_otp
        elif pressed_key == "-":
            Log.info("keypad_getotp: get_otp=[ CLEAR - ]")
            # clear the current entered keys and continue looping
            entered_otp = ""
        elif (pressed_key == "+") or (pressed_key == "*") or (pressed_key == "#"):
            # Handle other function keys pressed, clear the buffer and return the key pressed
            Log.info("keypad_getotp: get_otp=[ * or # ]")
            entered_otp = pressed_key
            # exit loop with this special keypad entry
            break
        else:
            Log.info("keypad_getotp: entered_otp=[" + entered_otp + "]")
            entered_otp = str(entered_otp) + str(pressed_key)
            Log.info("keypad_getotp: new appended entered_otp=[" + entered_otp + "]")

        # may need to mask the otp entered here later optionally
        display_update(line={3: str(entered_otp)}, delay=1.0)

        # 6 length hardcoded here ***
        if len(entered_otp) == numchars:
            Log.info("keypad_getotp: entered_otp of correct length=[" + entered_otp + "]")
            break

        if len(entered_otp) > numchars:
            entered_otp = ""
            Log.info("keypad_getotp: entered otp too long")
            display_update(line={3: "Invalid. Retry."}, delay=USER_DISPLAY_VIEW_WAIT)

        continue

    Log.info("keypad_getotp: exit entered_otp=[" + str(entered_otp) + "]")
    return entered_otp


# --- CRITICAL GLOBAL VARIABLES DECLARATION SECTION BELOW ---

Log.info("MAIN_KEYPAD: Started ...")
keypadobj = KeyPad()
Log.info("MAIN_KEYPAD: Completed ...")
