from main_includes import *

from main_display import *


'''
    baydoor_status = lcbobj.read_bay_door_status()
    Log.info("callback_baydoorsensor: baydoor_status=[" + str(baydoor_status) + "]")
#    Log.info("callback_baydoorsensor: buzzer for 0.5 secs")
#    lcbobj.start_buzzer(frequency=3)
#    time.sleep(0.5)
#    lcbobj.stop_buzzer()
#    Log.info("callback_baydoorsensor: buzzer stopped")
    Log.info("callback_baydoorsensor: Unexpected Bay Door Open Alarm Interrupt ... returning")
    return
'''


def lcb_callback_baydoorsensor(userdata):
    gflag_baydoor = True
    Log.info("\tlcb_callback_baydoorsensor: *** interrupt received")
    return


def lcb_buzzerbeep(frequency=1):
    Log.info("\tlcb_buzzerbeep: started ...")
    lcbobj.start_buzzer(frequency)
    time.sleep(0.1)
    lcbobj.stop_buzzer()
    Log.info("\tlcb_buzzerbeep: completed ...")
    time.sleep(SLEEP_SHORTDELAY)
    return


def lcb_update_powerstatus():
    # record if we are on raw or UPS power
    Log.info("\tlcb_update_powerstatus: check power status ... started")
    status, gap = lcbobj.is_raw_power_off()
    if not status and not lcbobj.raw_power:
        lcbobj.raw_power = True
    elif status:
        lcbobj.raw_power = False
    Log.info("\tlcb_update_powerstatus: updated lcbobj.raw_power=[" + str(lcbobj.raw_power) + "] ... completed")
    return


def lcb_reboot():
    Log.info("\tlcb_reboot: ... started")
    lcbobj.power_off()
    time.sleep(DEVICE_RESET_WAIT)
    lcbobj.power_on()
    time.sleep(DEVICE_RESET_WAIT)
    Log.info("\tlcb_reboot: ... completed")
    return


def lcb_init():
    Log.info("\tlcb_init: ... started")
    lcbobj.lcb_init()
    Log.info("\tlcb_init: ... completed")
    return


def lcb_get_isdoorlocked(door):
    Log.info("\tlcb_get_isdoorlocked: ... started")
    door_isopen = lcbobj.is_door_locked(door)
    Log.info("\tlcb_get_isdoorlocked: ... completed")
    return(door_isopen)


def lcb_reset():
    Log.info("\tlcb_reset: ... started")
    lcbobj.reset_lcb()
    time.sleep(SLEEP_LONGDELAY)
    Log.info("\tlcb_reset: ... completed")
    return


def lcb_get_opendoorslist():
    Log.info("\tlcb_get_opendoorslist: starting ...")
    doors = lcbobj.get_open_doors()
    Log.info("\tlcb_get_opendoorslist: return True ...")
    return(doors)


def lcb_open_lock(door_number):
    Log.info("\tlcb_open_lock: starting ...")
    lcbobj.open_lock(int(door_number), "factory-test-key")
    time.sleep(0.3)
    Log.info("\tlcb_open_lock: return True ...")
    return


def lcb_checkstatus():
    Log.info("\tlcb_checkstatus: starting ...")
    doors = lcbobj.get_open_doors()
    #  Testing for LCB error
    if doors is None:
        Log.info("\tlcb_checkstatus: LCB not On")
        display_update(line={1: "No Power", 2: "Try again", 3: "Sorry for the", 4: "Inconvinence"}, delay=USER_DISPLAY_VIEW_WAIT)
        lcb_reset()
        Log.info("\tlcb_checkstatus: return False ...")
        return False
    Log.info("\tlcb_checkstatus: return True ...")
    return True


def lcb_current_powerstatus():
    Log.info("\tlcb_current_powerstatus: starting ...")
    onraw = lcbobj.is_raw_power_off()
    if onraw:
        mode = "Ups"
    else:
        mode = "Raw"
    Log.info("\tlcb_current_powerstatus: mode=[" + str(mode) + "] completed ...")
    return mode


# --- CRITICAL GLOBAL VARIABLES DECLARATION SECTION BELOW ---

Log.info("MODULE - MAIN_LCB: invoked ...")

gflag_baydoor = False

lcbobj = LCBModbus()
lcbobj.bay_door_pin.isr(mraa.EDGE_BOTH, lcb_callback_baydoorsensor, None)
# need to document this 6 - is it a pin?
LCB_DOOR = 6

# Some starting up checks & resets
Log.info("\tMODULE - MAIN_LCB: init devices ...")
lcb_reboot()

Log.info("\tMODULE - MAIN_LCB: completed ...")
Log.info("\n")
