from main_includes import *

from main_display import *
from main_keypad import *


def sim_config_to_provider(sprovider):
    Log.info("sim_config_to_provider: configure SIM to sprovider=[" + sprovider + "]")

    display_update(line={2: "flash time 1 min", 3: "Sim:" + str(sprovider)}, delay=USER_DISPLAY_VIEW_WAIT)

    modem_powertoggle()
    cmd = '/root/pod-sd/'
    os.chdir(cmd)
    os.system('./pod.sh ' + str(sprovider))

    # not sure why we need a 50 sec sleep here ...???
    time.sleep(SIM_CONFIG_WAIT)

    display_clearall()
    display_update(line={2: "airtel ready to use"})

    Log.error("sim_config_to_provider returning ...")
    return


def sim_configure():
    Log.info("sim_configure: start ...")
    display_clearall()

    display_update(line={2: "1-Airtel 2-IoT", 3: "3-BSNL"})
    while True:
        pressed_key = keypad_getchar(KEY_PRESS_WAIT_SECS)
        if (pressed_key is None) or (pressed_key == ""):
            continue
        if pressed_key == "1":
            sim_config_to_provider('airtel')
            break
        elif pressed_key is "2":
            sim_config_to_provider('airtel_iot')
            break
        elif pressed_key is "3":
            sim_config_to_provider('bsnl')
            break
        else:
            Log.error("-- Error: Invalid mode selection")
            display_update(line={3: "invalid key"})
        continue

    Log.info("sim_configure: ended ...")
    return


# **** MODEM UTILITY FUNCTIONS ****


def modem_powertoggle():
    modem_poweroff()
    time.sleep(DEVICE_RESET_WAIT)
    modem_poweron()
    return


def modem_poweron():
    pin_poweron(modem_gpio)
    return


def modem_poweroff():
    pin_poweroff(modem_gpio)
    return


def pin_poweroff(pin):
    pin.write(True)
    return


def pin_poweron(pin):
    pin.write(False)
    return


'''
    strength = modemobj.get_signal_strength()
    if strength is not None:
        test = str(strength.split(":"))
        bars = str(test[1])
    else:
        strength = ""
        test = ""
        bars = ""

    sim = modemobj.get_service_provider()
    if sim is not None:
        mode = "GSM " + str(sim)
    else:
        sim = ""
        mode = "WiFi"
'''


def modem_current_status():
    sim = modemobj.get_service_provider()
    if sim is not None:
        mode = "GSM-" + str(sim)
    else:
        sim = ""
        mode = "WiFi"

    strength = modemobj.get_signal_strength()
    if strength is not None:
        test = str(strength.split(":"))
        # need to test is "bars" is the right value
        bars = str(test[1])
    else:
        strength = ""
        test = ""
        bars = ""

    return mode, strength, bars


def modem_diagnostics():
    Log.info("modem_diagnostics started ...")

    Log.info("modem_diagnostics *** NOT YET IMPLEMENTED *** ...")

    Log.info("modem_diagnostics ended ...")
    return


# --- CRITICAL GLOBAL VARIABLES DECLARATION SECTION BELOW ---


Log.info("MAIN_MODEM: Started ...")
modem_gpio = mraa.Gpio(13)
modem_gpio.dir(mraa.DIR_OUT)
modemobj = ModemPlugin()
Log.info("MAIN_MODEM: completed ...")

