from main_includes import *


# **** NETWORK INFO UTILITY FUNCTIONS ****


def net_current_macaddress():
    command = "timeout -k 10 5 ifconfig ra0 | grep HWaddr | cut -d ' ' -f 12 | tr -d : | tail -c 7"
    mac_address = commands.getoutput("timeout -k 10 {} {}".format(30, command)).strip()
    return mac_address


def net_current_ipaddress():
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    s.settimeout(0)
    try:
        # doesn't even have to be reachable
        s.connect(('10.255.255.255', 1))
        ip = s.getsockname()[0]
    except Exception:
        ip = '127.0.0.1'
    finally:
        s.close()
# added ...
    if ip is None: ip = ""
#
    ip = str(ip)
    return ip


def net_current_serialno():
    serialno = get_config_value(filename=CommonInfo.POD_CONFIG_FILE, section="general", field="pod_name")
    if serialno == "":
        serialno = net_current_macaddress()
    return serialno


def net_current_pingstatus():
    pingstatus = False
    try:
        command = "timeout -k 10 10 ping -c 1 -W 10 8.8.8.8"
        status, output = commands.getstatusoutput("timeout -k 10 {} {}".format(30, command))
        if status == 0:
            pingstatus = True
            Log.info("net_current_pingstatus ... ping success ...")
        else:
            Log.info("net_current_pingstatus ... ping failed by return ...")
    except Exception:
        Log.info("net_current_pingstatus ... ping failed by exception ...")
        pass
    return pingstatus


Log.info("MAIN_NETWORKING: Started ...")
Log.info("MAIN_NETWORKING: Completed!")
