from main_includes import *

from main_networking import *
from main_display import *
from main_keypad import *


# **************************
# ****  MAIN PINGTEST   ****
# **************************


def pingtest_display_stats(mode, success_count, total_count):
    display_clearall()

    display_setbacklight(True)
    smsg = "Ping (" + str(mode) + ")"
    display_update(line={1: smsg})

#    smsg = str(success_count) + " / " + str(total_count)
#    display_update(line={2: smsg})
#    smsg = str(int(float(100) * (float(success_count)/float(total_count)))) + " %"
#    display_update(line={3: smsg})

    smsg = "#: " + str(net_current_serialno())
    display_update(line={2: smsg})

    smsg = str(int(float(100) * (float(success_count)/float(total_count)))) + "% of " + str(total_count)
    display_update(line={3: smsg})

    return


def pingtest_main(mode="WiFi"):
    Log.info("pingtest_main: started ...")
    display_clearall()

    success_count = total_count = 0

    while True:
        Log.info("pingtest_main: run shell cmds ...")
        cmd = '/root/pod-sd/'
        os.chdir(cmd)
        if mode == "Modem":
            os.system('./pod.sh modem')
        elif mode == "WiFi":
            os.system('./pod.sh wifi')
        else:
            Log.info("pingtest_main: *** ERROR - BAD mode ***")
            return

        # Sleeps for INTER_PING_SECS secs between ping attempts
        time.sleep(INTER_PING_SECS)

        Log.info("pingtest_main: pinging ...")
        ping_result = net_current_pingstatus()
        total_count = total_count + 1
        if ping_result is True:
            success_count = success_count + 1

        Log.info("pingtest_main: ping result=[" + str(ping_result) + "]")
        Log.info("pingtest_main: success_count=[" + str(success_count) + "] / total=[" + str(total_count) + "]")
        pingtest_display_stats(mode, success_count, total_count)

        # Get a key press and if it is CLEAR (-) then break out of the ping test loop
        display_update(line={4: "CLEAR to Exit"})
        pressed_key = keypad_getchar(KEY_PRESS_WAIT_SECS)
        if pressed_key is "-":
            Log.info("pingtest_main: CLEAR entered - breaking out of loop ...")
            break

        continue

    if mode == "WiFi":
        Log.info("pingtest_main: return WIFi to AP mode now that ping tests are completed ...")
        os.system("wifi_mode ap")

    Log.info("pingtest_main: clear display ...")
    display_clearall()
    display_update(line={1: "Completed", 2: "PING", 3: "Check"}, delay=USER_DISPLAY_VIEW_WAIT)

    Log.info("check_display: stop check_display")
    display_clearall()
    Log.info("pingtest_main: ended ...")
    return
