"""
This file is used for pinging
"""
import re
import subprocess
import command_utils
import logging

LOGGER = logging.getLogger(__name__)


def ping(count=1, timeout=10):
    ping_status = False
    round_trip = None
    try:
        status, output = command_utils.status_output("timeout -k 10 {} ping -c {} -W {} 8.8.8.8".
                                                     format(int(timeout) + 10, count, timeout))
        if status == 0:
            ping_status = True
            round_trip = parse_ping_result(output.strip())
        else:
            LOGGER.error("Error in performing ping. Status: {}, Output: {}".format(status, output))
    except Exception:
        LOGGER.exception("Exception in performing ping")
    return ping_status, round_trip


def parse_ping_result(out):
    temp = None
    if out and len(re.findall(r"round-trip .*", out)) > 0:
        match = re.findall(r"round-trip .*", out)[0]
        if len(re.findall(r".* = (.*) ms", match)) > 0:
            res = re.findall(r".* = (.*) ms", match)[0].split("/")
            temp = {"min": str(res[0]), "avg": str(res[1]), "max": str(res[2])}
    return temp
