#!/usr/bin/python

import json


def add_micromax_modem_support():
    json_file = '/etc/usb-mode.json'
    pid_vid = '1c9e:9bfe'

    jsonfile = None
    try:
        jsonfile = open(json_file, "r+")
        data = json.load(jsonfile)
    finally:
        if jsonfile:
            jsonfile.close()

    if data and pid_vid not in data.get("devices"):
        tmp = {"t_vendor": 7326, "t_product": (39841,), "msg": [36]}
        data.get("devices")[pid_vid] = {}
        data.get("devices").get(pid_vid)['*'] = tmp

        try:
            jsonfile = open(json_file, "w+")
            jsonfile.write(json.dumps(data, indent=4, sort_keys=True))
        finally:
            if jsonfile:
                jsonfile.close()


def main():
    add_micromax_modem_support()


if __name__ == '__main__':
    try:
        main()
    except KeyboardInterrupt:
        pass
