#!/bin/sh


source $(pwd)/util/config.sh

if [ -n "$ThingName" ]; then
	WIFI_SSID=Qik_"$ThingName"
else
	WIFI_MAC=$(ifconfig ra0 | grep HWaddr | cut -d ' ' -f 12 | tr -d : | tail -c 7)
	WIFI_SSID="Qik_$WIFI_MAC"
fi

log "Desired SSID: $WIFI_SSID"
current_ssid=$(uci get wireless.ap.ssid)
log "Current SSID: $current_ssid"
if [ "$current_ssid" != "$WIFI_SSID" ]; then
	log "Desired and Current ssid are different. Resetting..."
	uci set wireless.ap.ssid=$WIFI_SSID
	uci commit wireless
	wifi
else
	log "Desired and Current WAN ssid are the same"
fi