"""
 Qikpod ini files Reader and writer

"""

import logging
import os.path
import ConfigParser
import os
import commentjson

# from manager.plugindef import PluginDef


LOGGER = logging.getLogger(__name__)


def get_config_value(filename, section, field, default=None):
    # print(filename, section, field)
    cfg_parser = ConfigParser.ConfigParser(allow_no_value=True)
    cfg_parser.read(filename)
    try:
        value = cfg_parser.get(section, field)
    except ConfigParser.NoOptionError as e:
        LOGGER.debug("{} not found in section {} in file {}".format(field, section, filename))
        LOGGER.debug("Assigning default value")
        value = default
    return value


def write_config_to_file(file_name, section, data):
    if not isinstance(data, dict):
        return Exception("Please give the data argument in dictionary")

    tmp_file = file_name + ".tmp"
    cfg_parser = ConfigParser.ConfigParser()
    cfg_parser.add_section(section)
    for key in data:
        cfg_parser.set(section, key, data[key])
    with open(tmp_file, 'w') as cfg_file:
        cfg_parser.write(cfg_file)
    os.rename(tmp_file, file_name)


def update_config_file(filename, section, field, value):
    cfg_parser = ConfigParser.ConfigParser(allow_no_value=True)
    cfg_parser.read(filename)
    cfg_parser.set(section=section, option=field, value=value)
    with open(filename, 'w+') as cfg_file:
        cfg_parser.write(cfg_file)

